function DM_PrepareRound()
{
	//determine the items
	$DM::Item0Spawn = DM_ConvertModItem($DM::Item0);
	$DM::Item1Spawn = DM_ConvertModItem($DM::Item1);
	$DM::Item2Spawn = DM_ConvertModItem($DM::Item2);
	$DM::Item3Spawn = DM_ConvertModItem($DM::Item3);
	$DM::Item4Spawn = DM_ConvertModItem($DM::Item4);
	if($DM::allowAltLoadout)
	{
		if(getRandom(0, 1) == 1)
			$DM::Item0Spawn = DM_ConvertModItem($DM::Item0alt);
		if(getRandom(0, 1) == 1)
			$DM::Item1Spawn = DM_ConvertModItem($DM::Item1alt);
		if(getRandom(0, 1) == 1)
			$DM::Item2Spawn = DM_ConvertModItem($DM::Item2alt);
		if(getRandom(0, 1) == 1)
			$DM::Item3Spawn = DM_ConvertModItem($DM::Item3alt);
		if(getRandom(0, 1) == 1)
			$DM::Item4Spawn = DM_ConvertModItem($DM::Item4alt);
	}
	
	//clean duplicates
	if($DM::Item4Spawn !$= "0")
	{
		if($DM::Item4Spawn $= $DM::Item3Spawn)
			$DM::Item4Spawn = 0;
		else if($DM::Item4Spawn $= $DM::Item2Spawn)
			$DM::Item4Spawn = 0;
		else if($DM::Item4Spawn $= $DM::Item1Spawn)
			$DM::Item4Spawn = 0;
		else if($DM::Item4Spawn $= $DM::Item0Spawn)
			$DM::Item4Spawn = 0;
	}
	
	if($DM::Item3Spawn !$= "0")
	{
		if($DM::Item3Spawn $= $DM::Item2Spawn)
			$DM::Item3Spawn = 0;
		else if($DM::Item3Spawn $= $DM::Item1Spawn)
			$DM::Item3Spawn = 0;
		else if($DM::Item3Spawn $= $DM::Item0Spawn)
			$DM::Item3Spawn = 0;
	}
	
	if($DM::Item2Spawn !$= "0")
	{
		if($DM::Item2Spawn $= $DM::Item1Spawn)
			$DM::Item2Spawn = 0;
		else if($DM::Item2Spawn $= $DM::Item0Spawn)
			$DM::Item2Spawn = 0;
	}
	
	if($DM::Item1Spawn !$= "0")
	{
		if($DM::Item1Spawn $= $DM::Item0Spawn)
			$DM::Item1Spawn = 0;
	}
	
	//shift items up if there's an empty slot
	if($DM::Item3Spawn $= "0")
	{
		$DM::Item3Spawn = $DM::Item4Spawn;
		$DM::Item4Spawn = 0;
	}
	
	if($DM::Item2Spawn $= "0")
	{
		$DM::Item2Spawn = $DM::Item3Spawn;
		$DM::Item3Spawn = $DM::Item4Spawn;
		$DM::Item4Spawn = 0;
	}
	
	if($DM::Item1Spawn $= "0")
	{
		$DM::Item1Spawn = $DM::Item2Spawn;
		$DM::Item2Spawn = $DM::Item3Spawn;
		$DM::Item3Spawn = $DM::Item4Spawn;
		$DM::Item4Spawn = 0;
	}
	
	if($DM::Item0Spawn $= "0")
	{
		$DM::Item0Spawn = $DM::Item1Spawn;
		$DM::Item1Spawn = $DM::Item2Spawn;
		$DM::Item2Spawn = $DM::Item3Spawn;
		$DM::Item3Spawn = $DM::Item4Spawn;
		$DM::Item4Spawn = 0;
	}
}

function DM_doRoundEnd()
{
	%winningScore = -2000000000;
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
		{
			if(%member.score > %winningScore)
			{
				%winningClients = 1;
				%winningScore = %member.score;
				%winningNames = "\c3" @ %member.getPlayerName();
				%winningLast = "";
			}
			else if(%member.score == %winningScore)
			{
				%winningClients++;
				if(%winningLast !$= "")
					%winningNames = %winningNames @ "\c2, " @ %winningLast;
				
				%winningLast = "\c3" @ %member.getPlayerName();
			}
		}
	}
	
	for(%b = 0; %b < $DefaultMinigame.numMembers; %b++)
	{
		%winMember = $DefaultMinigame.member[%b];
		if(isObject(%winMember))
		{
			if(%winMember.score >= %winningScore)
				centerPrint(%winMember, "<font:palatino linotype:64>\c3Victory!", 7);
			else
				centerPrint(%winMember, "", 7);
		}
	}
	
	if(%winningClients < 1)
	{
		messageAll('', "\c2Nobody won this round.");
		echo("Nobody won the round");
	}
	else if(%winningClients == 1)
	{
		messageAll('', %winningNames @ "\c2 won this round with \c3" @ %winningScore @ "\c2 points.");
		echo(stripMLControlChars(%winningNames) @ " won the round with " @ %winningScore @ " points");
	}
	else if(%winningClients > 1)
	{
		messageAll('', %winningNames @ "\c2, and " @ %winningLast @ "\c2 all won this round with \c3" @ %winningScore @ "\c2 points.");
		echo(stripMLControlChars(%winningNames) @ ", and " @ stripMLControlChars(%winningLast) @ " won the round with " @ %winningScore @ " points");
	}
}